package main

import (
	"fmt"
	"time"

	"remote-mic/networking"
	"remote-mic/audio"
)


func listen() error {
	fmt.Print("Listening for connection on port 8080... ")
	conn, err := networking.ListenAndAcceptTCP(":8080")
	if err != nil {
		return err
	}
	reader := networking.NewAsyncReader(conn)
	defer reader.Close()
	fmt.Println("Connection accepted!")

	recvChan := reader.RecvChan()
	for {
		buf, open := <-recvChan
		if !open {
			break
		}
		fmt.Printf("Bytes read: %d\n", len(buf))
		fmt.Printf("Buf: %v\n", buf)
		fmt.Printf("%v\n", string(buf))		
	}

	return nil
}

func pulsectlExample() {
	pulsectl := audio.NewPulsectl()
	err := pulsectl.LoadPipeSourceModule()
	if err != nil {
		panic(err)
	}
	time.Sleep(10 * time.Second)
	pulsectl.UnloadPipeSourceModule()
}
