package networking

import (
	"net"
)

const defaultBufSize = 1 * 1024


func ListenAndAcceptTCP(address string) (*net.TCPConn, error) {
	addr, err := net.ResolveTCPAddr("tcp", address)
	if err != nil {
		return nil, err
	}
	sock, err := net.ListenTCP("tcp", addr)
	if err != nil {
		return nil, err
	}
	conn, err := sock.AcceptTCP()
	if err != nil {
		return nil, err
	}
	conn.SetNoDelay(true)
	return conn, nil
}

func ConnectTCP(address string) (*net.TCPConn, error) {
	addr, err := net.ResolveTCPAddr("tcp", address)
	if err != nil {
		return nil, err
	}
	conn, err := net.DialTCP("tcp", nil, addr)
	if err != nil {
		return nil, err
	}
	conn.SetNoDelay(true)
	return conn, nil
}
