package main

import (
	"fmt"
	"io"
	"os"

	"remote-mic/networking"
	"remote-mic/audio"
)


func stream() error {
	conn, err := networking.ConnectTCP("localhost:8080")
	if err != nil {
		return err
	}
	writer := networking.NewAsyncWriter(conn)
	defer writer.Close()

	c := writer.SendChan()
	c <- []byte("cicasajtok")

	fmt.Println("Exiting.")

	return nil
}

func micStreamExample() {
	mic, err := audio.NewMicrophone()
	if err != nil {
		panic(err)
	}
	err = mic.Start()
	if err != nil {
		panic(err)
	}
	defer mic.Stop()

	for {
		io.Copy(os.Stdout, mic.AudioStream())
	}
}
